﻿(function () {
    "use strict";
	menu_SetColorBg();
    document.addEventListener( 'deviceready', onDeviceReady.bind( this ), false );
	document.addEventListener("resume", onResume, false);
	document.addEventListener("pause", onPause, false);

    function onDeviceReady() {
        document.addEventListener( 'pause', onPause.bind( this ), false );
        document.addEventListener( 'resume', onResume.bind( this ), false );
		document.addEventListener('backbutton', index_OnBackButton.bind(this), false);
		document.addEventListener('touchstart', handleTouchStart, false);
        document.addEventListener('touchmove', handleTouchMove, false);
		
		if (device.platform == "Android"){		
		window.addEventListener('native.keyboardshow', keyboardShowHandler);
		window.addEventListener('native.keyboardhide', keyboardHideHandler);
			if(device.version < 8){
				cordova.plugins.backgroundMode.setDefaults({
					title: translate('Приложение работает в фоновом режиме'),
					text: translate('Работает радиоплеер'),
					icon: 'icon.png',
					resume: true,
					hidden: true,
					bigText: false,
					silent: false
				});
			}	
		}
		else{
			StatusBar.overlaysWebView(true);
			StatusBar.styleLightContent();
            window.addEventListener('keyboardWillShow', (event) => {
                let page = ai_GetURLParam('page');
                if(page != 'vzchannel' && page != 'broadcast') return;
                $('#content').css('bottom', event.keyboardHeight+'px');
                $('#'+page).css('bottom', event.keyboardHeight+'px');
            });
            window.addEventListener('keyboardWillHide', () => {
                let page = ai_GetURLParam('page');
                if(page != 'vzchannel' && page != 'broadcast') return;
                $('#content').attr('style','');
                $('#'+page).attr('style', '');
            });
		}
		screen.orientation.lock('portrait');
		window.addEventListener("orientationchange", onOrientaionChange);        

		if (ai_GetURLParam('page') == 0) ai_SetPageURL('', ai_StartPage());
        index_ShowCurrentPage();

		if (window.PhoneCallTrap) {
			PhoneCallTrap.onCall(function(state) {
				console.log("CHANGE STATE: " + state);
				if (typeof(RadioPlayer) != 'undefined')
				{
					switch (state) {
						case "RINGING":		RadioPlayer.Pause();break;
						case "OFFHOOK":		RadioPlayer.Pause();break;
						case "IDLE":		RadioPlayer.Resume();break;
					}
				}
			});
		}
    };

function onPause() {};
function onResume() {};
})();

/*------------------------------------------ ON SCREEN ORIENTAION CHANGE -------------------------------------------------*/
function onOrientaionChange(e){	
	if (chatGUI) setTimeout(function(){if (chatGUI) chatGUI.updateVisibility();}, 500);
}

/*------------------------------------------ ON SHOW KEYBOARD -------------------------------------------------*/
function keyboardShowHandler(e)
{
	if (!document.activeElement) return;	
	var bottom = window.innerHeight - e.keyboardHeight - Math.round(window.innerHeight / 15);
	var pos = document.activeElement.getBoundingClientRect();
	var top = parseInt($('body').css("top"), 10);
	if (isNaN(top)) top = 0;
	var activeBottom = pos.bottom - top;
	if (activeBottom > bottom)
	{
		$('body').css("position", "relative");
		$('body').css("top", (Math.min(Math.round(activeBottom - bottom), e.keyboardHeight) * -1) + "px");
	}
}

/*------------------------------------------ ON HIDE KEYBOARD -------------------------------------------------*/
function keyboardHideHandler(e){	$('body').css("top", "auto");		}

/*------------------------------------------ SHOW CURRENT PAGE -------------------------------------------------*/
function index_ShowCurrentPage()
{
	cPage = ai_StartPage();
	if (ai_GetURLParam('page') != 0) cPage = ai_GetURLParam('page');
	$('#header_sub_menu').empty().removeClass('active').removeClass('thee').removeClass('two');

	switch( cPage )
	{
		case 'vzchannel':		{menu_Main(); updateStatusActive('#menu_vz_radio'); channel_Main(ai_GetURLParam('params'),'vz');break;}
		case 'fmchannel':		{menu_Main(); updateStatusActive('#menu_vz_radio'); channel_Main(ai_GetURLParam('params'),'fm');break;}
		case 'vz':				{menu_Main(); updateStatusActive('#menu_vz_radio'); load_main('vz');break;}
		case 'news':			{menu_Main(); updateStatusActive('#menu_news'); load_main('news');break;}
		case 'podcast':			{menu_Main(); updateStatusActive('#menu_podcast',); load_main('podcast');break;}		
		case 'fav':				{menu_Main(); updateStatusActive('#menu_fav'); load_main('fav'); break;}
		case 'search':			{menu_Main(); updateStatusActive('#menu_search'); load_main('search');break;}
		case 'userchannels':	{menu_Main(); updateStatusActive('#menu_settings'); load_main('userchannels');break;}
		case 'broadcast':		{menu_Main(); updateStatusActive('#menu_settings'); channel_Main(ai_GetURLParam('params'),'broadcast');break;}
		case 'settings':		{menu_Main(); updateStatusActive('#menu_settings'); settings_Main();break;}
	}
}

/*------------------------------------------ ON BACK BUTTON -------------------------------------------------*/
function index_OnBackButton( obj )
{
	if($('#news_article_content:visible').length){
		article_Hide();
		return;
	}		
	console.log('--------------- START --------------');
	for(var i=0;i<g_aHistory.length;++i)
		console.log(g_aHistory[i]);
	console.log('---------------- END ---------------');
	if (g_aHistory.length < 2) { window.plugins.appMinimize.minimize() ;return;}
	
	g_aHistory.pop();
	window.history.pushState({}, '', g_aHistory.pop());
	index_ShowCurrentPage();	
}

var xDown = null;
var yDown = null;
function getTouches(evt) {
    return evt.touches ||             
        evt.originalEvent.touches; 
}

function handleTouchStart(evt) {
    const firstTouch = getTouches(evt)[0];
    xDown = firstTouch.clientX;
    yDown = firstTouch.clientY;
};

function handleTouchMove(evt) {
    if (!xDown || !yDown) {
        return;
	}
	let page = ai_GetURLParam('page');
	if(page != 'podcast' && page != 'vzchannel') return;
	if(page == 'vzchannel' && !$('#bcc_podcast_tab').length) return;	

    if (evt.target.className === "position_color" ||
    evt.target.id === "music_position" ||
    evt.target.id === "music_time") return;

    var xUp = evt.touches[0].clientX;
    var yUp = evt.touches[0].clientY;

    var xDiff = xDown - xUp;
    var yDiff = yDown - yUp;

    if (Math.abs(xDiff) > Math.abs(yDiff)) {/*most significant*/
        if (xDiff > 0 && xDiff > 5) {            
			/* left swipe */       
			if(playerShown == 'false' && !$('#wrapper_player').is(":visible")){
				$('#wrapper_player').show(); return;
			}
			$('#player_podcast').addClass('open');
			if(playerShown == 'false'){
				$('.arrow_left').hide();
				$('#wrapper_left').hide();
				$('#wrapper_right').show();
				$('.arrow_left.right').show();
			}
        } else if (xDiff < -5){
			/* right swipe */ 
			if(!$('#player_podcast').hasClass('open')) return;
			$('#player_podcast').removeClass('open');
			if(playerShown == 'false'){
				$('#wrapper_player').hide();
				playerShown = 'true';
				ai_Set('playerShown', 'true');
			}
        }
    } else {
        if (yDiff > 0) {
            /* up swipe */
        } else {
            /* down swipe */
        }
    }
    /* reset values */
    xDown = null;
    yDown = null;
};