﻿
/*-------------------------------------------------- GET NEWS LIST ---------------------------------------------------------*/
function client_GetNewsList( fnCallback, nStart, nCount, cErrorDOM )
{
	client_Request(cErrorDOM, 'get_news_list',
		'position=' + nStart + '&count=' + nCount + '&lang=' + ai_Lang(), fnCallback);
}

/*-------------------------------------------------- GET ARTICLE -----------------------------------------------------------*/
function client_GetArticle( fnCallback, cArticleID, cErrorDOM )
{
	client_Request( cErrorDOM, 'get_news', 'id=' + cArticleID, fnCallback);
}

/*--------------------------------------------- GET VOLNOREZ CHANNELS ------------------------------------------------------*/
function client_GetVZChannels( fnCallback, nGenreID, sort, nStart, nCount, cErrorDOM )
{
	if (typeof(nGenreID) == 'undefined') nGenreID = 0;
	client_Request( cErrorDOM, 'get_channels', 
		'count=' + g_aConfig['page_ini_elements_cnt'] + '&genre_id=' + nGenreID + '&sort=' + sort +
		'&position=' + nStart + '&count=' + nCount + '&lang=' + ai_Lang(), fnCallback);
}

/*--------------------------------------------- GET FM CHANNELS ---------------------------------------------------------*/
function client_GetFMChannels( fnCallback, nCountryID, cErrorDOM )
{
	if (typeof(nCountryID) == 'undefined') nCountryID = 0;	
	client_Request( cErrorDOM, 'get_fm_stations', 'country_id=' + nCountryID + '&lang=' + ai_Lang(), fnCallback);
}

/*----------------------------------------------- GET GENRES -----------------------------------------------------------*/
function client_GetVZGenres( fnCallback, cErrorDOM )
{
	client_Request( cErrorDOM, 'get_genres', 'lang=' + ai_Lang(), fnCallback);
}

/*--------------------------------------------- GET FM COUNTRIES --------------------------------------------------------*/
function client_GetFMCountries( fnCallback, cErrorDOM )
{
	client_Request( cErrorDOM, 'get_fm_countries', 'lang=' + ai_Lang(), fnCallback);
}

/*---------------------------------------------- GET AUTH INFO ----------------------------------------------------------*/
function client_GetAuthInfo( cLogin, cPass, fnCallbackOK, fnCallbackFail )
{
	client_Request(undefined, 'get_auth_info', 'login=' + encodeURIComponent(cLogin.trim()) + '&pw=' + cPass + '&lang=' + ai_Lang(), fnCallbackOK, fnCallbackFail );
}

/*--------------------------------------------- GET USER CHANNELS ------------------------------------------------------*/
function client_GetUserChannels( fnCallback, cErrorDOM )
{
	client_AuthRequest( cErrorDOM, 'get_user_channels', '', fnCallback);
}

/*----------------------------------------------- GET FM PARAMS --------------------------------------------------------*/
function client_GetFMParams( fnCallback, cFMStationID, cErrorDOM )
{
	client_Request( cErrorDOM, 'get_fm_params', 'id=' + cFMStationID + '&lang=' + ai_Lang(), fnCallback);
}

/*--------------------------------------------- GET CHANNEL PARAMS -----------------------------------------------------*/
function client_GetChannelParams( cChannelID, cErrorDOM, fnCallbackOK, fnCallbackFail )
{
    let param = 'id=' + cChannelID +'&lang=' + ai_Lang();
    if (ai_Get('User_id'))
        param += '&user=' + ai_Get('User_id'); 
    client_Request(cErrorDOM, 'get_channel_params', param , fnCallbackOK, fnCallbackFail);
}

/*----------------------------------------------- SEARCH SUGGEST -------------------------------------------------------*/
function client_SearchSuggest( fnCallback, cRequest, cErrorDOM )
{
	client_Request(cErrorDOM, 'search_suggest', 'input=' + cRequest, fnCallback);
}

/*-------------------------------------------------- SEARCH ------------------------------------------------------------*/
function client_Search( fnCallback, cRequest, cErrorDOM )
{
	client_Request(cErrorDOM, 'search', 'input=' + cRequest, fnCallback);
}

/*----------------------------------------------- AUTH REQUEST ---------------------------------------------------------*/
function client_AuthRequest( cErrorDOM, cFunction, cParams, fnCallbackOK, fnCallbackFail )
{
	if ( cParams.length ) cParams+= '&';
	cParams += 'login=' + encodeURIComponent(ai_Get('login')) + '&pw=' + ai_Get('pw');
	client_Request( cErrorDOM, cFunction, cParams, fnCallbackOK, fnCallbackFail );
}

/*----------------------------------------------- MEDIA LOGIN ----------------------------------------------------------*/
function client_MediaLogin( cErrorDOM, cID, cSalt, fnCallbackOK, fnCallbackFail )
{
	var cParams = 'id=' + cID + '&salt=' + cSalt + '&login=' + ai_Get('login') + '&pw=' + ai_Get('pw');
	client_Request( cErrorDOM, 'media_login', cParams, fnCallbackOK, fnCallbackFail );
}

/*----------------------------------------------- GET SMILEYS ----------------------------------------------------------*/
function client_GetSmileys( cChannelID, fnCallbackOK, fnCallbackFail )
{
	client_Request( undefined, 'get_smileys', 'id=' + cChannelID, fnCallbackOK, fnCallbackFail );
}

/*-------------------------------------------------- SEND REPORT ------------------------------------------------------------*/
function client_Report(sType, sReportValue, sItemID, fnCallbackOK)
{
	client_Request(undefined, 'report', 'type=' + sType + '&value=' + sReportValue + '&item=' + sItemID, fnCallbackOK);
}

/*--------------------------------------------- SEND local list favorite stations ------------------------------------*/
function client_LocalListFav(fnCallback, list) {

    let aChannels = new Array();
    aChannels = JSON.parse(list);
    client_Request(undefined, 'set_favorite_stations', 'list=' + aChannels + '&login=' + ai_Get('login') + '&pw=' + ai_Get('pw') , fnCallback);
}

/*-------------------------------------------------- Update favorite status ------------------------------------------------------------*/
function client_UpdateFav(fnCallback, id, value) {

    client_Request(undefined, 'update_favorite_station', 'id=' + id + '&val=' + (value == true ? 1 : 0) + '&user=' + ai_Get('User_id'), fnCallback);
}

/*-------------------------------------------------- Get list favorite stations ------------------------------------------------------------*/
function client_GetListFavoriteStation(fnCallback) {

    client_Request(undefined, 'get_favorite_stations', 'user=' + ai_Get('User_id'), fnCallback);
}

/*-------------------------------------------------- Get list podcasts ------------------------------------------------------------*/
function client_GetPodcastList(fnCallback, nStart, nId) {

    client_Request(undefined, 'get_podcasts', 'start=' + nStart + (nId ? ('&id='+ nId): ''), fnCallback);
}

/*-------------------------------------------------- Get list station news ------------------------------------------------------------*/
function client_GetStationNewsList(fnCallback, nStart, nId) {
	
    client_Request(undefined, 'get_station_news', 'start=' + nStart + (nId ? ('&id='+ nId): ''), fnCallback);
}

function client_GetDlgOrder(fnCallback, nId) {

    client_Request(undefined, 'get_dlg_order', 'id='+ nId + '&user=' + ai_Get('User_id') + '&lang=' + ai_Lang(), fnCallback);
}


function client_AddOrder(fnCallback, nId, track , artist , comment){

	client_Request(undefined, 'add_order', 'id='+ nId + '&user=' + ai_Get('User_id') + '&name=' + track 
	+ '&artist=' + artist + '&comment=' + comment + '&lang=' + ai_Lang() , fnCallback);

}

function client_CancelOrder(fnCallback, nId, order){

	client_Request(undefined, 'cancel_order', 'id='+ nId + '&user=' + ai_Get('User_id') + '&order=' + order, fnCallback);
}

function client_GetIdActiveOrders(fnCallback, nId){

	client_Request(undefined, 'get_ids_orders_user', 'id='+ nId + '&user=' + ai_Get('User_id'), fnCallback);
}

function client_GetDataOrder(fnCallback, nId){

	client_Request(undefined, 'get_data_order', 'id='+ nId, fnCallback);
}


/*------------------------------------------------- REQUEST ------------------------------------------------------------*/
function client_Request( cErrorDOM, cFunction, cParams, fnCallbackOK, fnCallbackFail )
{
    var aT = translate('Неверный формат ответа сервера');
	
	if (cParams != '') cParams += '&';
	cParams += 'vers=2';
	if (cParams != '') cParams = '?' + cParams;

	console.log(ai_GetInfo('server_url') + 'mapp-newlistener/' + cFunction + cParams);
	$.get(ai_GetInfo('server_url') + 'mapp-newlistener/' + cFunction + cParams, function (data) {
		if (typeof (data) == 'string')
		{
			try { data = JSON.parse(data); }
			catch (error)
			{
				if (typeof (fnCallbackFail) != 'undefined') { window[fnCallbackFail](aT, data); return; } 
				client_DownloadError(cErrorDOM, aT);
			}
		}
		if (typeof (data) == 'object' && data.result == 'OK')
		{
			if (typeof (fnCallbackOK) == 'string')
				window[fnCallbackOK](data);
			else
				fnCallbackOK(data);
		}
		else 
		{
			if( typeof(fnCallbackFail) != 'undefined' ) {window[fnCallbackFail](aT, data);return;} 
			client_DownloadError(cErrorDOM, aT);
		}
	}).fail(function(data){
		if( typeof(fnCallbackFail) != 'undefined' ) {window[fnCallbackFail]('', data);return;} 
		client_DownloadError(cErrorDOM); 
	});
}

/*------------------------------------------------- DOWNLOAD ERROR -----------------------------------------------------*/
function client_DownloadError( cErrorDOM, cError )
{
	if (typeof(cError) == 'undefined') cError = '';
	var cErrorTitle = translate('Ошибка');
	if (typeof(cErrorDOM) == 'undefined'){ai_ErrorDlg(cErrorTitle, cError);return;}
	cOut = '<div id="client_download_error">';
		cOut+= '<div id="client_error_header">' + cErrorTitle + '</div>';
		cOut+= '<div id="client_error_text">' + cError + '</div>';
	cOut+= '</div>';
	$(cErrorDOM).html(cOut);
}