/**
 * Created by Expert001 on 18.02.2015.
 */

var objCurAudio;
var domCurPlayElem = null;
var domCurPlayerItem = null;
var g_nUpdateInterval = false;
var nCount = 0;
var g_nUpdateCountTrack = false;
var CountTrack = 0;
var UpdateCountTrack = true;

$(document).ready(function()
{
	objCurAudio = new Audio();
	objCurAudio.volume = 1;
	player_music_SetAudioEvents();
	player_music_StartPlaying();
	player_ClickBtn();
});

/** * Set audio play/pause click */
function player_music_StartPlaying()
{
	$("#content").on('click',".play_btn_music", function(){
		var element = $(this);
		var src = element.attr('audio-src');
		var nId = element.attr('data_id');
		if(!objCurAudio.src || objCurAudio.src != src || nCount == 0){
			$(".media-thumb").removeClass("current");

			if(domCurPlayElem){
				domCurPlayerItem.removeClass("std_media_pause");
				player_music_StopPositionUpdate();
			}
			domCurPlayElem = $(this).closest('.media-thumb');
			nCount = nId;
			StopPlayerStations();
			player_music_InitPosition();
			domCurPlayerItem = element;
			domCurPlayElem.addClass("current");
			objCurAudio.pause();
			NoActiveNotification();
			objCurAudio.src = src;
			player_music_StartPositionUpdate();
			ActiveNotification();
			objCurAudio.play();	
			UpdateCountListenersTrack();			
		} else {
			if(element.hasClass('std_media_pause')){
				element.removeClass("std_media_pause");
				$('#podcast_play').removeClass("pause");
				NoActiveNotification();
				objCurAudio.pause();
				UpdateCountTrack = false;
				domCurPlayerItem.removeClass("std_media_waiting");
				$('#podcast_play').removeClass("waiting");				
			} else {
				StopPlayerStations();
				element.addClass("std_media_pause");
				$('#podcast_play').addClass("pause");			
				ActiveNotification();
				objCurAudio.play();
				UpdateCountTrack = true;
			}			
		}
	});
}
/* * Sets audio position.  *  * @param position	The position value [0..1]. */
function player_music_SetPosition(position){		if (objCurAudio) objCurAudio.currentTime = objCurAudio.duration * position;		}

/** * Starts a timer to update the playback position.  */
function player_music_StartPositionUpdate(){		if (g_nUpdateInterval === false) g_nUpdateInterval = setInterval(player_music_UpdatePosition, 100);		}

/** * Stops a timer that updates the playback position.  */
function player_music_StopPositionUpdate()
{
	if (g_nUpdateInterval !== false)
	{
		clearInterval(g_nUpdateInterval);
		g_nUpdateInterval = false;
	}
	domCurPlayElem.find('#music_position').remove();
	domCurPlayElem.removeClass("current");
	ClearTimerTrack(true);
	NoActiveNotification();
}
/**
 * Updates playback position. 
 */
function player_music_UpdatePosition()
{
	if (objCurAudio)
	{
		let element = $('#podcast_play');
		if (element.hasClass("pause")){

			if(objCurAudio.currentTime > 0)
			{
				domCurPlayerItem.removeClass("std_media_waiting");
				element.removeClass("waiting");
			}
			else 
			{
				domCurPlayerItem.addClass("std_media_waiting");
				element.addClass("waiting");				
			}
        }
		var nPos = 100 * objCurAudio.currentTime / objCurAudio.duration;
		if (nPos > 100) nPos = 100;
		if (nPos == 100) player_music_PlayNext();
		
		var domMediaJPPosition = $('#music_position');
		if (domMediaJPPosition.length && domMediaJPPosition.slider('option', 'in_slide_state')=='false'){
			domMediaJPPosition.slider('value', nPos);
			let time = player_music_secondsToMMSS(Math.floor(objCurAudio.duration));
			time = time == 'NaN:NaN' ? '00:00': time;
			$('#music_time').text(player_music_secondsToMMSS(Math.floor(objCurAudio.currentTime))+"/"+time);
		}
	}
}


/** * On audio waiting state */
function player_music_OnWaiting()
{
	$('.play_btn_music').removeClass("std_media_waiting");
	$('#podcast_play').removeClass("pause").addClass("waiting");
	domCurPlayerItem.removeClass("std_media_pause").addClass("std_media_waiting");
}

/** * On audio error event */
function player_music_OnError()
{
	if ( objCurAudio.error.code != 1)
	{
		objCurAudio.pause();
		domCurPlayerItem.removeClass("std_media_pause").removeClass("std_media_waiting");
		$('#podcast_play').removeClass("pause").removeClass("waiting");
		let sError;
		switch(objCurAudio.error.code)
		{
			/*case 1: {sError = 'The fetching process for the media resource was aborted by the user agent at the user's request.';break;}*/
			case 2: {sError = 'A network error of some description caused the user agent to stop fetching the media resource, after the resource was established to be usable.';break;}
			case 3: {sError = 'An error of some description occurred while decoding the media resource, after the resource was established to be usable.';break;}
			case 4: {sError = 'The media resource indicated by the src attribute was not suitable.';break;}
		}
		alert(sError);
	}
}

/** * On audio playing state */
function player_music_OnPlaying(){	
	$('#podcast_play').removeClass("waiting").addClass("pause");
	domCurPlayerItem.removeClass("std_media_waiting").addClass("std_media_pause");		
}

/** * On audio end event */
function player_music_OnEnded(){	
	$('#podcast_play').removeClass("waiting").removeClass("pause");
	domCurPlayerItem.removeClass("std_media_waiting").removeClass("std_media_pause");	
}

/** * Clear audio events */
function player_music_RemoveAudioEvents()
{
	objCurAudio.removeEventListener("waiting", player_music_OnWaiting);
	objCurAudio.removeEventListener("error", player_music_OnError);
	objCurAudio.removeEventListener("playing", player_music_OnPlaying);
}

/** * Set audio events */
function player_music_SetAudioEvents()
{
	objCurAudio.addEventListener("waiting", player_music_OnWaiting);
	objCurAudio.addEventListener("error", player_music_OnError);
	objCurAudio.addEventListener("playing", player_music_OnPlaying);
	objCurAudio.addEventListener("ended", player_music_OnEnded);
}
function player_music_secondsToMMSS(seconds)
{
	var min = Math.floor(seconds/60);
	var sec = (seconds%60);
	return (min < 10 ? '0' + min : min) + ':' + (sec < 10 ? '0' + sec : sec);
}

function player_music_InitPosition()
{
	domCurPlayElem.append('<div id="music_position"><div class="position_color"><div><div id="music_time"></div></div>');
	var domSlider = $("#music_position");
	domSlider.slider({
		step: 0.05,
		range: "min",
		start: function(event, ui){domSlider.slider('option', 'in_slide_state', 'true');},
		stop: function(event, ui){
			domSlider.slider('option', 'in_slide_state', 'false'); 
			player_music_SetPosition(domSlider.slider('value')/100.0);
			}
		});
	domSlider.slider('option', 'in_slide_state', 'false');
}

function player_music_PlayNext()
{	
	if(domCurPlayElem == null) return;
	if(nCount == $('.media-thumb').length)
	{
		objCurAudio.pause();
		player_music_StopPositionUpdate();		
	}
	else
		domCurPlayElem.next().find('.play_btn_music').click();		
}
function player_music_PlayPrev()
{	
	if(domCurPlayElem == null) return;
	if(nCount == 0)
	{
		objCurAudio.pause();
		player_music_StopPositionUpdate();		
	}
	else
		domCurPlayElem.prev().find('.play_btn_music').click();		
}

function UpdateCountListenersTrack(){
	ClearTimerTrack(true);
	UpdateCountTrack = true;
	if(!g_nUpdateCountTrack) g_nUpdateCountTrack = setInterval(TimerForTrack, 1000);
}

function ClearTimerTrack(clear = false){
	if (g_nUpdateCountTrack !== false)
	{
		clearInterval(g_nUpdateCountTrack);
		g_nUpdateCountTrack = false;
	}
	if(clear){
		UpdateCountTrack = false;
		CountTrack = 0;
	}
}

function TimerForTrack(){
	if(!objCurAudio.duration)		ClearTimerTrack();	
	if(UpdateCountTrack)		CountTrack += 1;

	if( (CountTrack > 5 || CountTrack > Math.floor(objCurAudio.duration)/2) && UpdateCountTrack){
		ClearTimerTrack(true);
		$.get(ai_GetInfo('server_url') + 'mapp-listener/listen_podcast?id='+ domCurPlayElem.attr('media_id') +'&vers=1', function (data) {});
	}
}

function ActiveNotification(){/*android*/
	let title_notif = domCurPlayElem.find('.media-author').text();
	let text_notif = domCurPlayElem.find('.media-title').text();
	if (device.platform == "Android"){
		if(device.version < 8){			 
			cordova.plugins.backgroundMode.setDefaults({ title: title_notif, text: text_notif });
			cordova.plugins.backgroundMode.enable();
		}
		else
			cordova.plugins.foregroundService.start( title_notif , text_notif, "icon");	
	}	
}

function NoActiveNotification(){ /*android*/
	if (device.platform == "Android"){	
		if(device.version < 8)		cordova.plugins.backgroundMode.disable();		
		else						cordova.plugins.foregroundService.stop();
	}	
}

function StopPlayerStations(){
	if($('#menu_player:visible').length){
		if($('#menu_player_play').hasClass('playing'))
			$('#menu_player_play').click();
	}
}

function StopPlayer(){
	if(objCurAudio){
		nCount = 0;
		if(!objCurAudio.paused){
			NoActiveNotification();
			objCurAudio.pause();
			UpdateCountTrack = false;
		}
	}
}

function player_ClickBtn()
{	
	$("#player_podcast").on('click',"#podcast_next", function(){
		if(playerShown == 'false') return;
		player_music_PlayNext();
	});
	$("#player_podcast").on('click',"#podcast_prev", function(){
		if(playerShown == 'false') return;
		player_music_PlayPrev();
	});
	$("#player_podcast").on('click',"#podcast_play", function(){
		if(playerShown == 'false') return;
		if(domCurPlayElem)
			domCurPlayElem.find('.play_btn_music').click();
		else
			$('.play_btn_music[data_id="1"]').click();	
	});
	$("#player_podcast").on('click',"#podcast_stop", function(){
		if(playerShown == 'false') return;
		let elem = $('.media-thumb.current');
		if(objCurAudio){
			nCount = 0;
			if(!objCurAudio.paused){
				objCurAudio.pause();
				domCurPlayerItem.removeClass("std_media_pause").removeClass("std_media_waiting");				
				player_music_StopPositionUpdate();
				UpdateCountTrack = false;
			}					
		}
		$('#podcast_play').removeClass("pause").removeClass("waiting");
		elem.find('#music_position').remove();
		elem.removeClass("current");
		domCurPlayElem = null;
	});
}
