var sync = null;

var timerUpdateOrder = null;
var btnTextOrder = "";
var timeOrder = 0;
function order_GUI()
{
    /* synchronization*/
    var orderBtn = $('.channel_order');
    sync = new LiveSync({
        url: orderBtn.attr('sync-url'),
        password: orderBtn.attr('token'),
        role: 'user',

        /* synchronization ready*/
        onReady: function() {
            sync.subscribe('allow_orders');
            if (ai_IsLoggedIn(false)) {
                client_GetIdActiveOrders('sync_IdOrders', $('#menu_player').attr('station_id'));
            }
        },
        /* notification about event*/
        onNotification: function(msg) {
            switch (msg.event) {
                case 'allow_orders':
                    $("#header").toggleClass('track', msg.data.allowed);
                break;
                case 'update_order_status':
                    let status =' ' + translate(msg.data.status == 'completed' ? 'выполнен' : 'отклонен');
                    if($('.order_track_dlg').length){
                        let el = $('#list_order_count[data-id="'+msg.id+'"]').remove();  
                        let text =  translate('Заказ')+' '+ el.find('#list_order_nameartist').text() + ' - ' + el.find('#list_order_nametrack').text();
                        if( $('#list_order_count').length == 0){
                            $('.dlg_orders_btn, .dlg_orders, .dlg_form_btn').hide();
                            $('.dlg_form').show();
                            $('#order_user_track').removeClass('old');
                        }
                        header_Toast(text + status , msg.data.status == 'completed' ? 'success': 'danger');
                    }
                    else{
                        client_GetDataOrder('sync_DataOrder', msg.id);
                    } 
                break;
            }
        }
    });
    window.g_OrdersSync = sync;
    /* order dialog*/
}
function sync_DataOrder(data){
    if ( data.message != ""){
        let text = translate('Заказ')+' '+data.message;
        let status =' ' + translate(data.status == 'completed' ? 'выполнен' : 'отклонен');
        header_Toast(text + status , data.status == 'completed' ? 'success': 'danger');
    }
}

function sync_IdOrders(data){
    if ( data.status == "success" && data.message != "")
    data.message.forEach(el => {  sync.subscribe('update_order_status', el.id, el.sign); });
}
$('#header').on('click', '.channel_order',function(){
    if (!ai_IsLoggedIn(false)) { login_Main(); return; }
    client_GetDlgOrder('printDlg', $('#menu_player').attr('station_id'));
});
$('#dlg_track').on("click","#order_comment",  function(){
    el = $(this);
    domEl = el.closest('#list_order_comment');
    domEl.find('#order_comment_desc').slideToggle();
    if(el.hasClass("expand")){
        el.text(translate('Свернуть'));
        el.removeClass("expand");
    } else {
        el.text(translate('Развернуть'));
        el.addClass("expand");
    }
});
$('#dlg_track').on("click",".dlg_orders_btn, .dlg_form_btn",  function(){
    $('.dlg_form').slideToggle();
    $('.dlg_orders').slideToggle();
    $('#order_user_track').toggleClass('old');
});
$('#dlg_track').on('click', '#list_order_count_cancel',function(){
    let el = $(this).closest('#list_order_count');
    client_CancelOrder('cancelOrder', $('#menu_player').attr('station_id'), el.attr('data-id'));
   
});
$('#dlg_track').on('click', '#track_dlg_Close', function(){
    stopUpdateTimer();
    $('.order_track_dlg').remove();
    $('#wrapper_login').hide();
	$('#content').removeClass('loginShow');
});
$('#dlg_track').on("focusout", ".order_tracks", function(e){
    checkActiveBtn();
});
$("#dlg_track").on('click', "#order_user_track", function(){
    name_track = $("#name_track").val();
    name_artist = $("#name_artist").val();
    if( name_track == '' || name_artist == '')
        return;
    comment_user = $("#oreder_comment").val();
    client_AddOrder('answerAddOrder', $('#menu_player').attr('station_id'), name_track , name_artist , comment_user ? comment_user : '' );
});

function cancelOrder(aResult){
    if ( aResult.status == "success"){
        sync.notify('cancel_order', {}, aResult.id, aResult.sign);
        $('#list_order_count[data-id="'+aResult.id+'"]').remove();
        if( $('#list_order_count').length == 0){
            $('.dlg_orders_btn, .dlg_orders, .dlg_form_btn').hide();
            $('.dlg_form').show();
            $('#order_user_track').removeClass('old');
        }    
        if(aResult.time == 0 && timeOrder != 0){
            $('#order_user_track').text(btnTextOrder);
            stopUpdateTimer();
        }
    }
}
function answerAddOrder(data){
    if (data.status == 'OK') {
        sync.notify('new_order', {}, data.id, data.sign);
        $('#track_dlg_Close').click();
    } else {
        $('.dlg_message_error').css('opacity', '1');
        $('.dlg_message_error').text(data.message).stop(true).animate({'opacity' : 0}, 10000);
    }
}
function printDlg(aResult){   
    $('.order_track_dlg').remove();
    $('#dlg_track').append(aResult.message);
    if(aResult.time != null && aResult.time != 0 ){
        timeOrder = aResult.time;
        startUpdateTimer();
        if($('#list_order_count').length == 0)
            $('.dlg_orders_btn, .dlg_orders, .dlg_form_btn').hide();
        else{ 
            $('.dlg_form').hide();
            $('#order_user_track').addClass('old');
        }
    }else{
        if($('#list_order_count').length == 0)              $('.dlg_orders_btn, .dlg_orders, .dlg_form_btn').hide();
        else                                                $('.dlg_orders').hide();
    }
    $('#wrapper_login').show();
	$('#content').addClass('loginShow');
    $('.order_track_dlg').addClass('active');    
}
function stopUpdateTimer(){
    if(timerUpdateOrder != null)
        clearTimeout(timerUpdateOrder);
    timeOrder = 0;
    checkActiveBtn();
}
function startUpdateTimer(){
    btnTextOrder = $('#order_user_track').text();
    setTimeout(function run() {	updateTime(); timerUpdateOrder = setTimeout(run, 1000);}, 1);
}
function updateTime(){
    let m = parseInt(timeOrder/60);
    let sec = timeOrder - m*60;
    $('#order_user_track').text(''+ m +' : '+ ( sec < 10 ? ('0'+ sec) : sec));
    if(timeOrder == 0){ stopUpdateTimer(); $('#order_user_track').text(btnTextOrder);  return; }
    timeOrder -= 1;
};
function checkActiveBtn(){
    if( $(".order_tracks#name_track").val() != "" && $(".order_tracks#name_artist").val() != "" && timeOrder == 0)
        $('#order_user_track').removeClass('inactive');
    else
        $('#order_user_track').addClass('inactive');        
}

function header_Toast(cMessage, cType)
{
	var ID = $(".message_header_toast").length ? Number($(".message_header_toast").attr('data_id')) + 1: 1;
	$('.wrapper_toast').append($("<div class='message_header_toast type_"+cType+"' data_id='"+ID+"'>"+cMessage+"</div>"));
	setTimeout(function(){ $(".message_header_toast[data_id='"+ID+"']").animate({opacity:0}, 1500, function(){ $(".message_header_toast[data_id='"+ID+"']").remove();});}, 2500);
}