


/**
 *  Volnorez player.
 */
function VPlayer()
{
	this.cCurStationID = "";
	var _self = this;
    var objDescription = null;
	var bPaused = false;
    this.objPlayer = new AudioStreamPlayer(false, 'js/lib/decoderWorker.min.js', 'link');
	
	/*--------------------------------------------- ON DESCRIPTION CHANGED --------------------------------------------*/
	this.objPlayer.onDescriptionChanged = function( objDesc )
    {
        objDescription = objDesc;
		var text = '';
		var i;

		/* RJs*/
		if (objDesc.rjs)
		{
			for (i = 0; i < objDesc.rjs.length; i++)
			{
				if (text != '') text += ', ';
				text += ai_HTMLEscape(objDesc.rjs[i]);
			}
		}
		/* Current music*/
		if (objDesc.music)
		{
			for (i = 0; i < objDesc.music.length; i++)
			{
				if (text != '') text += ', ';
				text += ai_HTMLEscape(objDesc.music[i].title);
			}
		}
		/* Air description*/
		if (objDesc.hasOwnProperty('air_desc') && objDesc.air_desc != '')
		{
			if (text != '') text += ', ';
			text += ai_HTMLEscape(objDesc.air_desc);
		}

		if ($('.vplayer_Description').length)
		{
			var children = $('.vplayer_Description').find('div');
			for ( var i = 0; i < children.length; ++i)
				children[i].innerHTML = text;
		}
		if(text == ''){
			$('#menu_player_info').removeClass('full_info');
		}
		else if($('#menu_player_play').hasClass('playing')){
				$('#menu_player_info').addClass('full_info');
		}
		
		/* 'Android'*/
		if (device.platform == "Android"){		
			if(device.version < 8)
				cordova.plugins.backgroundMode.setDefaults({ text : text });			
			else if($('#menu_player_play').hasClass('playing'))
				cordova.plugins.foregroundService.start($('#menu_player_title').text() , text, "icon");
		}
		/* Show appropriate status*/
		if ( objDesc.hasOwnProperty("status") )
		{
			switch (objDesc.status)
			{
				case "online":
					$('.vplayer_DescCont').css('display', "block");
					$('.vplayer_Connecting').css('display', "none");
					$('.vplayer_Offline').css('display', "none");
					$('.vplayer_Limited').css('display', "none");
					break;

				case "offline":
					$('.vplayer_DescCont').css('display', "none");
					$('.vplayer_Connecting').css('display', "none");
					$('.vplayer_Offline').css('display', "block");
					$('.vplayer_Limited').css('display', "none");
					break;

				case "limited":
					$('.vplayer_DescCont').css('display', "none");
					$('.vplayer_Connecting').css('display', "none");
					$('.vplayer_Offline').css('display', "none");
					$('.vplayer_Limited').css('display', "block");
					break;
			}
		}
	};

	/*--------------------------------------------- ON DESCRIPTION CHANGED --------------------------------------------*/
	this.objPlayer.onBuffering = function( bResult )
	{
		var id = _self.cCurStationID;
		$('#menu_player_play').toggleClass('buffering', bResult);
		$('#fm .channel_cont[channel_id="'+id+'"] .channel_play').toggleClass('buffering', bResult);
		$('#fav .channel_cont[channel_id="'+id+'"] .channel_play').toggleClass('buffering', bResult);
		$('#vz .channel_cont[channel_id="'+id+'"] .channel_play').toggleClass('buffering', bResult);
	};

	/*--------------------------------------------- ON DESCRIPTION CHANGED --------------------------------------------*/
	this.objPlayer.onPlay = onPlay;

	function onPlay(bResult)
	{
		$('#menu_player_play').toggleClass('playing', bResult);
		$('#menu_player_info').toggleClass('playing', bResult);
		if (bResult)
		{
			var id = _self.cCurStationID;
			$('#fm .channel_cont[channel_id="'+id+'"] .channel_play').addClass('playing');
			$('#fav .channel_cont[channel_id="'+id+'"] .channel_play').addClass('playing');
			$('#vz .channel_cont[channel_id="'+id+'"] .channel_play').addClass('playing');
		}
		else
		{
			$('.playing').removeClass('playing');
		}
	};

	/*-------------------------------------------------- PLAY FM-STATION -----------------------------------------------*/
	this.PlayFM = function( cStationID )
	{
		StopPlayerRecords();
		onPlay(true);	
		$('#menu_player_info').removeClass('full_info');	
		/*Android*/
		if (device.platform == "Android"){			
			if(device.version < 8){
				cordova.plugins.backgroundMode.setDefaults({ title: $('#menu_player_title').text() });
				cordova.plugins.backgroundMode.enable();
			}
			else{
				cordova.plugins.foregroundService.start($('#menu_player_title').text() , "", "icon");
			}
		}
				
		bPaused = false;
		_self.cCurStationID = cStationID;
		client_GetFMParams('player_OnPlay', cStationID, undefined);
	};

	/*------------------------------------------------ PLAY VOLNOREZ STATION ------------------------------------------*/
	this.PlayVZ = function( cChannelID )
	{
		StopPlayerRecords();
		onPlay(true);
		$('#menu_player_info').removeClass('full_info');
		/*'Android'*/
		if (device.platform == "Android"){				
			if(device.version < 8){				
				cordova.plugins.backgroundMode.setDefaults({ title: $('#menu_player_title').text() });
				cordova.plugins.backgroundMode.enable();
			}
			else
				cordova.plugins.foregroundService.start($('#menu_player_title').text() , "", "icon");
		}
		bPaused = false;
		_self.cCurStationID = cChannelID;
		client_GetChannelParams(cChannelID, undefined, 'player_OnPlay', 'player_OnPlayFail');
    };

	this.Pause = function()
	{
		if (bPaused) return;
		/*Android*/
		if (device.platform == "Android"){	
			if(device.version < 8)					cordova.plugins.backgroundMode.disable();			
			else									cordova.plugins.foregroundService.stop();	
		}				
		
		bPaused = true;
		if (_self.cCurStationID != "") _self.objPlayer.stop();
	};

	this.Resume = function()
	{
		if (!bPaused) return;
		bPaused = false;
		if (_self.cCurStationID != "")
		{  
			/*'Android'*/
			if (device.platform == "Android"){	
				if(device.version < 8){
					cordova.plugins.backgroundMode.setDefaults({ title: $('#menu_player_title').text() });
					cordova.plugins.backgroundMode.enable();
				}
				else
					cordova.plugins.foregroundService.start($('#menu_player_title').text() , "", "icon");
			}
			_self.objPlayer.play();
		}
	};

    /*----------------------------------------------- UPDATE DESCRIPTION ----------------------------------------------*/
    this.UpdateDescription = function ()
    {
        if (objDescription !== null) this.objPlayer.onDescriptionChanged(objDescription);
    };

	/*------------------------------------------------------ STOP ------------------------------------------------------*/
	this.Stop = function()
	{
		bPaused = false;
		objDescription = null;
		/*Android*/
		if (device.platform == "Android"){			
			if(device.version < 8)				cordova.plugins.backgroundMode.disable();
			else								cordova.plugins.foregroundService.stop();			
		}
		$('#menu_player_info').removeClass('full_info');
		_self.cCurStationID = "";
		this.objPlayer.stop();
	};

	/*---------------------------------------------------- PLAY FROM DATA ----------------------------------------------*/
	this.PlayFromData = function( objData )
	{
		this.objPlayer.stop();
		this.objPlayer.connect(objData.live_url);
		this.objPlayer.play();
	};

	/*------------------------------------------------------- GET PLAYER -----------------------------------------------*/
	this.GetPLayer = function()	{		return this.objPlayer;	};
}

/*------------------------------------------------------ ON PLAY ---------------------------------------------------*/
function player_OnPlay( objData ){
	if(objData.bc){
		let el = $('#menu_player_fav');
		if(sync && objData.id != el.attr('channel_id')){
			sync.disconnect();
			sync = null;
		}		
		el.attr('channel_id', objData.id );
		if (objData.fav) 
			el.addClass('fav');
		else 
			el.removeClass('fav');
		$('#header').addClass('fav');
		$("#header").toggleClass('track', objData.allowed);
		if(objData.bc == '1' && sync == null){			
			let btn = $('.channel_order');	
			if(objData.sync_url){
				btn.attr('sync-url',objData.sync_url);	
				if(objData.token )
					btn.attr('token',objData.token);
				order_GUI();
			}
		}
	}
	else{
		if(sync){
			sync.disconnect();
			sync = null;
		}
		$('#header').removeClass('fav').removeClass('track');
        $('#menu_player_fav').removeAttr('channel_id');
	}
	RadioPlayer.PlayFromData( objData );	
};

/*------------------------------------------------------ ON PLAY FAIL ----------------------------------------------*/
function player_OnPlayFail( cError, objData ){		ai_ErrorDlg('', cError);	};

function StopPlayerRecords(){
	if($('.media-thumb.current').length){
		let el = $('.media-thumb.current');
		let playBnt = el.find('.play_btn_music');
		if(playBnt.hasClass('std_media_pause'))
			playBnt.click();
	}	
};

if (typeof(RadioPlayer) == 'undefined') var RadioPlayer = new VPlayer();
